<?php
/**
 * @version   1.1 May 7, 2012
 * @author    RocketTheme http://www.rockettheme.com
 * @copyright Copyright (C) 2007 - 2012 RocketTheme, LLC
 * @license   http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 only
 *
 */

// no direct access
defined( '_JEXEC' ) or die('Restricted access');
define ( 'MICRONEWS', true);

require_once (JPATH_SITE.DS.'modules'.DS.'mod_articles_latest'.DS.'helper.php');

/**
 * @package RocketTheme
 * @subpackage rokmicronews
 */
class modRokMicroNewsHelper
{
    public static function getList($params)
	{
		$items = modArticlesLatestHelper::getList($params);

		$text_length = intval($params->get( 'preview_count', 200) );
		$tags 		= $params->get('strip_tags', "a,i,br");

		$i=0;
		$lists	= array();
		foreach ( $items as $row )
		{
		    //process content plugins
		    $text = JHTML::_('content.prepare',$row->introtext);
			$lists[$i]->id = $row->id;
			$lists[$i]->thumb = self::getThumb($row->introtext,$params->get('thumb_width',160));
			$lists[$i]->created = $row->created;
			$lists[$i]->modified = $row->modified;
			$lists[$i]->link = $row->link;
			$lists[$i]->title = htmlspecialchars( $row->title );
			$lists[$i]->introtext = self::prepareContent( $text, $text_length, $tags);
			$i++;
		}

		return $lists;
	}
	
	private static function getThumb($text, $size=70, $reflections=false) {
		
		preg_match("/\<img.+?src=\"(.+?)\".+?\/>/", $text, $matches);

		$paths = array();
		
		if (isset($matches[1])) {
			$image_path = $matches[1];

			//joomla 1.5 only
			$full_url = JURI::base();
			
			//remove any protocol/site info from the image path
			$parsed_url = parse_url($full_url);
			
			$paths[] = $full_url;
			if (isset($parsed_url['path']) && $parsed_url['path'] != "/") $paths[] = $parsed_url['path'];
			
			
			foreach ($paths as $path) {
				if (strpos($image_path,$path) !== false) {
					$image_path = substr($image_path,strpos($image_path, $path)+strlen($path));
				}
			}
			
			// remove any / that begins the path
			if (substr($image_path, 0 , 1) == '/') $image_path = substr($image_path, 1);
			
			//if after removing the uri, still has protocol then the image
			//is remote and we don't support thumbs for external images
			if (strpos($image_path,'http://') !== false ||
				strpos($image_path,'https://') !== false) {
				return false;
			}
			
			// create a thumb filename
			$file_div = strrpos($image_path,'.');
			$thumb_ext = substr($image_path, $file_div);
			$thumb_prev = substr($image_path, 0, $file_div);
			$thumb_path = $thumb_prev . "_thumb" . $thumb_ext;
	
			// check to see if this file exists, if so we don't need to create it
			if (function_exists("gd_info") && !file_exists($thumb_path)) {
				// file doens't exist, so create it and save it
				include_once('thumbnail.inc.php');
				$thumb = new Thumbnail($image_path);
				
				if ($thumb->error) { 
					if (MICRONEWS)	echo "ROKMICRONEWS ERROR: " . $thumb->errmsg . ": " . $image_path;
					return false;
				}
				$thumb->resize($size);
				if ($reflections) {
					$thumb->createReflection(30,30,60,false);
				}
				if (!is_writable(dirname($thumb_path))) {
					$thumb->destruct();
					return false;
				}
				$thumb->save($thumb_path);
				$thumb->destruct();
			}
			return ($thumb_path);
		} else {
			return false;
		}
	}
	
	private static function prepareContent( $text, $length=200 , $tags = "a,i,br") {
		// strips tags won't remove the actual jscript
		$text = preg_replace( "'<script[^>]*>.*?</script>'si", "", $text );
		$text = preg_replace( '/{.+?}/', '', $text);
		
		$tags = preg_replace("/\s/ism", "", $tags);
		$tags = "<".implode(">,<", explode(",", $tags)) . ">";
		
		$text = strip_tags($text,$tags);
		// cut off text at word boundary if required
		if (strlen($text) > $length) {
			$text = substr($text, 0, strpos($text, ' ', $length)) . "..." ;
		} 
		return $text;
	}
	
	private static function processPlugins($article) {

        $app = JFactory::getApplication();

        $dispatcher	=& JDispatcher::getInstance();
        $limitstart = 0;
        $params		=& $app->getParams();

        JPluginHelper::importPlugin('content');
        $results = $dispatcher->trigger('onContentPrepare', array ('com_content.article', & $article, & $params, $limitstart));

        return $results;
    }
	
	public static function _getJSVersion() {

        return "";
    }
}
